/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { FinancialSeries } from "./FinancialSeries";
import { ITrendLineSeries_$type } from "./ITrendLineSeries";
import { IndicatorDisplayType_$type } from "./IndicatorDisplayType";
import { DependencyProperty } from "igniteui-react-core";
import { TrendLineType_$type } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { PenLineCap_$type } from "igniteui-react-core";
import { DoubleCollection } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { AxisRange } from "./AxisRange";
import { CategoryFrame } from "./CategoryFrame";
import { Number_$type, typeCast, enumGetBox, EnumUtil, runOn, markType, markDep } from "igniteui-react-core";
import { Rect } from "igniteui-react-core";
import { ScalerParams } from "./ScalerParams";
import { ISortingAxis_$type } from "./ISortingAxis";
import { CategoryTrendLineManagerFactory } from "./CategoryTrendLineManagerFactory";
import { FinancialSeriesView } from "./FinancialSeriesView";
import { FinancialBucketCalculator } from "./FinancialBucketCalculator";
import { TrendResolutionParams } from "./TrendResolutionParams";
import { CategorySeries } from "./CategorySeries";
import { NotImplementedException } from "igniteui-react-core";
import { Path } from "igniteui-react-core";
import { PropertyMetadata } from "igniteui-react-core";
import { isNaN_ } from "igniteui-react-core";
import { PathGeometry } from "igniteui-react-core";
import { GeometryGroup } from "igniteui-react-core";
import { Pool$1 } from "igniteui-react-core";
import { LineGeometry } from "igniteui-react-core";
import { Defaults } from "./Defaults";
import { Extensions } from "igniteui-react-core";
import { IndicatorRenderer } from "./IndicatorRenderer";
/**
 * @hidden
 */
export let FinancialIndicator = /*@__PURE__*/ (() => {
    class FinancialIndicator extends FinancialSeries {
        get_em() {
            return true;
        }
        cd() {
            return new FinancialIndicatorView(this);
        }
        o2(a) {
            super.o2(a);
            this.x6 = a;
        }
        constructor() {
            super();
            this._indicatorColumn = null;
            this.x5 = null;
            this.uf = new CategoryFrame(3);
            this.uh = new CategoryFrame(3);
            this.ud = new CategoryFrame(3);
            this.indicatorColumn = new List$1(Number_$type, 0);
            this.x5 = new AxisRange(-100, 100);
        }
        yj(a) {
            if (this.uu != null && !this.uu.c1()) {
                this.pr(true);
            }
        }
        yb(a, b, c) {
            if (isNaN_(b.x) || isNaN_(b.y)) {
                return false;
            }
            let d = this.uu;
            let e = 0;
            if (d != null) {
                e = d.e4(d.l7);
            }
            if ((a.y >= e && a.y <= b.y) || (a.y <= e && a.y >= b.y)) {
                return true;
            }
            return false;
        }
        bu() {
            if (this.bv == 0) {
                return 1;
            }
            else {
                return super.bu();
            }
        }
        tu(a) {
            if (this.ub == null || this.uu == null) {
                return Rect.empty;
            }
            let b = this.te(a);
            let c = this.cg.by;
            let d = this.cg.bx;
            let e = this.getEffectiveViewport1(this.cg);
            let f = new ScalerParams(0, c, d, this.uu.ch, e);
            f.b = this.h3();
            let g = this.aj(this.ub, this.ud.f, this.v8(this.cg), this.wa(this.cg), a, true);
            if (g == null) {
                return Rect.empty;
            }
            let h = g[0];
            let i = g[1];
            let j = Math.abs(b.x - h[0]);
            let k = Math.abs(b.x - i[0]);
            let l = this.uu.ej(this.uu.l7, f);
            let m = 1;
            if (j < k) {
                let n = h[0] - 0.5 * m;
                let o = h[1];
                let p = l;
                return new Rect(0, n, Math.min(o, p), m, Math.max(o, p) - Math.min(o, p));
            }
            else {
                let q = i[0] - 0.5 * m;
                let r = i[1];
                let s = l;
                return new Rect(0, q, Math.min(r, s), m, Math.max(r, s) - Math.min(r, s));
            }
        }
        f5(a, b) {
            let c = this.tj(this.to(a), true, false);
            if (this.x8 == 1) {
                if (this.yb(a, c, b)) {
                    return true;
                }
            }
            if (this.x8 == 1 || this.x8 == 0) {
                if (this.f4(a, b)) {
                    return true;
                }
            }
            if (this.x8 == 2) {
                if (this.f8(a, b)) {
                    return true;
                }
            }
            return false;
        }
        np(a, b, c, d) {
            super.np(a, b, c, d);
            if (this.ub != null && typeCast(ISortingAxis_$type, this.ub) !== null) {
                this.ub.i$i();
            }
            if (this.x6.ca) {
                this.x6.b8.g$e(a, b, c, d);
            }
            if (d != null && this.vn.containsKey(d)) {
                let e = this.vn.tryGetValue(d, d);
                d = e.p1;
            }
            if (this.ub != null && typeCast(ISortingAxis_$type, this.ub) !== null) {
                a = 4;
                b = 0;
                c = this.c7.count;
            }
            switch (a) {
                case 3:
                    if (this.ya(b, c, d)) {
                        this.yl(b, c, d);
                        this.yj(true);
                    }
                    break;
                case 2:
                    if (this.ya(b, this.c7.count - b, d)) {
                        this.yl(b, this.c7.count - b, d);
                        this.yj(true);
                    }
                    break;
                case 1:
                    if (this.ya(b, this.c7.count - b, d)) {
                        let f = new Array(c);
                        for (let g = 0; g < c; g++) {
                            f[g] = 0;
                        }
                        this.indicatorColumn.s(b, f);
                        this.yl(b, this.c7.count - b, d);
                        this.yj(true);
                    }
                    break;
                case 0:
                    if (this.ya(b, this.c7.count - b, d)) {
                        this.indicatorColumn.v(b, c);
                        this.yl(b, this.c7.count - b, d);
                        this.yj(true);
                    }
                    break;
                case 4:
                    if (this.ya(b, this.c7.count - b, d)) {
                        this.indicatorColumn = new List$1(Number_$type, 2, this.c7.count);
                        let h = new Array(c);
                        for (let i = 0; i < c; i++) {
                            h[i] = 0;
                        }
                        this.indicatorColumn.s(0, h);
                        this.yl(b, this.c7.count - b, d);
                        this.yj(true);
                    }
                    break;
            }
        }
        get_x7() {
            return 0;
        }
        get x7() {
            return this.get_x7();
        }
        get yw() {
            return this.c(FinancialIndicator.ym);
        }
        set yw(a) {
            this.h(FinancialIndicator.ym, a);
        }
        yg() {
            return -1;
        }
        get indicatorColumn() {
            return this._indicatorColumn;
        }
        set indicatorColumn(a) {
            this._indicatorColumn = a;
        }
        pa(a, b, c, d) {
            switch (b) {
                case "XAxis":
                    this.x6.cg();
                    break;
                case "TrendLineType":
                    let e = EnumUtil.getEnumValue(TrendLineType_$type, d);
                    if (e != 0) {
                        this.x6.b8 = CategoryTrendLineManagerFactory.a(this.x6.b8, this.ub, this.qt, this, this.da);
                    }
                    break;
            }
            super.pa(a, b, c, d);
            if (this.x6.ca && this.x6.b8.g$b(a, b, c, d)) {
                this.pr(false);
                let f = typeCast(FinancialIndicatorView.$, this.cf);
                if (f != null && f.ca) {
                    f.b8.g$b(a, b, c, d);
                }
                this.om();
            }
            switch (b) {
                case "FastItemsSource":
                    if (this.c7 != null) {
                        this.indicatorColumn = new List$1(Number_$type, 2, this.c7.count);
                        let g = new Array(this.c7.count);
                        for (let h = 0; h < this.c7.count; h++) {
                            g[h] = 0;
                        }
                        this.indicatorColumn.s(0, g);
                        this.yl(0, this.c7.count, null);
                        if (this.uu != null && !this.uu.c1()) {
                            this.us.b0.e(this.hk);
                            this.pr(this.fr && c != null);
                        }
                    }
                    break;
                case "TrendLineBrush":
                    this.pg(b);
                    break;
                case FinancialIndicator.$$p[0]:
                    this.nk(true, this.cg);
                    this.qg();
                    this.pr(false);
                    this.om();
                    break;
                case "OpenColumn":
                case "HighColumn":
                case "LowColumn":
                case "CloseColumn":
                case "VolumeColumn":
                    if (this.c7 != null) {
                        if (this.indicatorColumn.count != this.c7.count) {
                            this.indicatorColumn = new List$1(Number_$type, 2, this.c7.count);
                            let i = new Array(this.c7.count);
                            for (let j = 0; j < this.c7.count; j++) {
                                i[j] = 0;
                            }
                            this.indicatorColumn.s(0, i);
                        }
                        if (this.ya(0, this.c7.count - 1, b)) {
                            this.yk();
                        }
                    }
                    break;
                case "XAxis":
                    if (this.ub != null && (typeCast(ISortingAxis_$type, this.ub) !== null || typeCast(ISortingAxis_$type, c) !== null)) {
                        this.yk();
                    }
                    break;
                case "YAxis":
                case FinancialIndicator.$$p[1]:
                    this.yk();
                    this.om();
                    break;
                case "TrendLineType":
                    this.om();
                    break;
            }
        }
        ia(a, b, c) {
            if (this.indicatorColumn == null) {
                return super.ia(a, b, c);
            }
            let d = this.getEffectiveViewport1(this.cg);
            let e = this.v2(this.cg.by, this.cg.bx, d);
            let f = new ScalerParams(0, this.cg.by, this.cg.bx, this.ub.ch, d);
            f.c = this.cv.t6;
            return this.ic(this.indicatorColumn, a, this.ub, f, e, runOn(this, this.v1), b, c);
        }
        jg(a, b) {
            if (this.indicatorColumn == null) {
                return super.jg(a, b);
            }
            return this.jh(a, b, this.ub, runOn(this, this.v1), this.indicatorColumn);
        }
        je(a, b) {
            if (this.indicatorColumn == null) {
                return super.je(a, b);
            }
            return this.jf(a, b, this.ub, runOn(this, this.v1), this.indicatorColumn);
        }
        get_gl() {
            return true;
        }
        ya(a, b, c) {
            if (c == null) {
                return true;
            }
            if (this.yc(a, b).contains(c)) {
                return true;
            }
            return false;
        }
        yl(a, b, c) {
            this.x9(a, b);
        }
        aq(a) {
            if (this.c7 == null) {
                return null;
            }
            if (a != null && a == this.uu) {
                return this.x5;
            }
            return null;
        }
        fp(a) {
            let b = this.c7 != null ? this.c7.indexOf(a) : -1;
            let c = this.cg.by;
            c = c.copy();
            let d = this.cg.bx;
            let e = new Rect(0, 0, 0, 1, 1);
            let f = this.ts(this.cg);
            if (b >= 0 && Rect.l_op_Inequality(c, null) && Rect.l_op_Inequality(d, null)) {
                if (this.ub != null) {
                    let g = new ScalerParams(0, e, e, this.ub.ch, f);
                    let h = this.ub.ej(b, g);
                    if (h < c.left + 0.1 * c.width) {
                        h = h + 0.4 * c.width;
                    }
                    if (h > c.right - 0.1 * c.width) {
                        h = h - 0.4 * c.width;
                    }
                    c.x = h - 0.5 * c.width;
                }
                if (this.uu != null && this.indicatorColumn != null && b < this.indicatorColumn.count) {
                    let i = new ScalerParams(0, e, e, this.uu.ch, f);
                    i.b = this.h3();
                    let j = this.uu.ej(this.indicatorColumn._inner[b], i);
                    if (j < c.top + 0.1 * c.height) {
                        j = j + 0.4 * c.height;
                    }
                    if (j > c.bottom - 0.1 * c.height) {
                        j = j - 0.4 * c.height;
                    }
                    c.y = j - 0.5 * c.height;
                }
                this.co.au(this.cv, c, true);
            }
            return b >= 0;
        }
        gm(a, b, c) {
            let d = super.gm(a, b, c);
            if (this.indicatorColumn == null || this.indicatorColumn.count == 0) {
                d = false;
            }
            return d;
        }
        xh(a, b) {
            super.xh(a, b);
            let c = b.by;
            let d = b.bx;
            let e = this.getEffectiveViewport1(b);
            let f = this.ub;
            let g = this.uu;
            let h = new ScalerParams(0, c, d, f.ch, e);
            let i = new ScalerParams(0, c, d, g.ch, e);
            i.b = this.h3();
            let j = this.ub.ag();
            let k = j[0];
            let l = j[1];
            a.f.clear();
            a.m.clear();
            a.p.clear();
            let m = 0;
            let n = typeCast(ISortingAxis_$type, this.ub);
            if (n != null && n.i$b.count != this.c7.count) {
                return;
            }
            m = this.v2(c, d, e);
            let o = this.yg();
            if (o == -1) {
                o = this.trendLinePeriod;
            }
            let p = typeCast(FinancialIndicatorView.$, b);
            if (p.ca) {
                p.b8.prepareLineCore(a.p, this.trendLineType, this.indicatorColumn, o, (q) => this.ub.ej(q, h), (q) => this.uu.ej(q, i), ((() => {
                    let $ret = new TrendResolutionParams();
                    $ret.e = b.b0.b;
                    $ret.f = b.b0.c;
                    $ret.g = b.b0.d;
                    $ret.a = m;
                    $ret.d = this.hk;
                    $ret.h = d;
                    $ret.i = c;
                    $ret.b = l;
                    $ret.c = k;
                    return $ret;
                })()));
            }
            let q = this.ub.em(2, h) - this.ub.em(1, h);
            for (let r = b.b0.c; r <= b.b0.d; ++r) {
                let s;
                if (n == null) {
                    s = b.b0.getBucket(r);
                }
                else {
                    let t = n.i$b._inner[r];
                    let u = n.i$d(t);
                    let v = this.indicatorColumn._inner[r];
                    let w = v;
                    let x = u;
                    while (r < b.b0.d) {
                        t = n.i$b._inner[r + 1];
                        x = n.i$d(t);
                        if (x - u > q) {
                            break;
                        }
                        r++;
                        let y = this.indicatorColumn._inner[r];
                        v = Math.min(v, y);
                        w = Math.max(w, y);
                    }
                    let z = NaN;
                    if (!isNaN_(u)) {
                        z = this.ub.ej(u, h);
                    }
                    s = [z, v, w];
                }
                if (!isNaN_(s[0])) {
                    if (this.ub != null && typeCast(ISortingAxis_$type, this.ub) !== null) {
                        s[0] = s[0] + m;
                    }
                    else {
                        s[0] = f.ej(s[0], h) + m;
                    }
                    s[1] = g.ej(s[1], i);
                    if (b.b0.b > 1 || n != null) {
                        s[2] = g.ej(s[2], i);
                    }
                    else {
                        s[2] = s[1];
                    }
                    a.f.add(s);
                }
            }
            return;
        }
        nk(a, b) {
            super.nk(a, b);
            let c = b;
            c.cb(a);
            if (c.ca) {
                c.b8.g$d();
            }
        }
        ul() {
            switch (this.x8) {
                case 1: return 1;
                case 2: return 1;
                case 0: return 12;
            }
            return 1;
        }
        xj(a, b) {
            super.xj(a, b);
            let c = typeCast(FinancialIndicatorView.$, b);
            let d = (e) => a.f._inner[e][0];
            let e = (f) => a.f._inner[f][1];
            if (c.ca) {
                c.b8.g$d();
                c.b8.g$g(a.p);
            }
            let f = b.bx;
            let g = this.getEffectiveViewport1(b);
            let h = 0;
            let i = this.su;
            let j = this.x1;
            if (b.b3(a)) {
                c.cb(false);
                if (a.f.count > 0) {
                    switch (this.x8) {
                        case 0:
                            let k = CategorySeries.vi(a.f, a.f.count - 1, f, b.by, false);
                            c.cf(a.f.count, d, e, true, k);
                            break;
                        case 1:
                            if (this.uu != null) {
                                h = this.v6(b);
                            }
                            else {
                                h = 0.5 * (f.top + f.bottom);
                            }
                            let l = CategorySeries.vi(a.f, a.f.count - 1, f, b.by, false);
                            c.cd(a.f.count, d, e, true, h, l);
                            break;
                        case 2:
                            h = this.v6(b);
                            c.ce(a.f.count, d, e, true, h);
                            break;
                        default: throw new NotImplementedException(0);
                    }
                }
                b.b5(a);
            }
            let m = a.f;
            let n = this.c7.count;
            this.uk.a2(this, this.vj(), runOn(this, this.t3), this.v8(b), this.wa(b));
            let o = false;
            let p = this.uk.b;
            if (p != null) {
                o = true;
            }
            this.uk.ak = i;
            this.uk.ag = i;
            if (o) {
                let q = new ScalerParams(0, b.by, b.bx, this.ub.ch, g);
                this.uk.f = false;
                this.xg(m, -1, n, this.ub, q, b.q);
            }
            this.uk.ad(c.cx, true, false, true, false);
            this.uk.ad(c.cz, true, false, true, false);
            this.uk.ad(c.cy, false, true, false, false);
            c.cy._opacity = 0.8 * this.uk.j * this.hg;
            this.uk.ad(c.cw, true, false, false, false);
            this.uk.ak = j;
            this.uk.ag = j;
            if (o) {
                let r = new ScalerParams(0, b.by, b.bx, this.ub.ch, g);
                this.uk.f = true;
                this.xg(m, -1, n, this.ub, r, b.q);
            }
            this.uk.ad(c.ct, true, false, true, false);
            this.uk.ad(c.cv, true, false, true, false);
            this.uk.ad(c.cu, false, true, false, false);
            c.cu._opacity = 0.8 * this.uk.j * this.hg;
            this.uk.ad(c.cs, true, false, false, false);
            c.ch();
        }
        qf() {
            super.qf();
            if (this.index < 0) {
                return;
            }
            if (this.x6.ca) {
                this.x6.ci();
            }
        }
        yk() {
            if (this.x6.ca) {
                this.x6.b8.g$i();
            }
            this.x9(0, this.indicatorColumn.count);
            if (this.uu != null && !this.uu.c1()) {
                this.pr(this.fr && this.dp);
            }
        }
        n2(a) {
            super.n2(a);
            this.a5.exportTrendlineData(this, a, this.x6.b8.g$j);
        }
        a7(a) {
            if (this.x8 == 1 || this.x8 == 2) {
                return 3;
            }
            else if (this.x8 == 0) {
                return 2;
            }
            return a;
        }
    }
    FinancialIndicator.$t = /*@__PURE__*/ markType(FinancialIndicator, 'FinancialIndicator', FinancialSeries.$, [ITrendLineSeries_$type]);
    FinancialIndicator.ym = /*@__PURE__*/ DependencyProperty.i("ActualTrendLineBrush", Brush.$, FinancialIndicator.$, /*@__PURE__*/ new PropertyMetadata(2, null, (a, b) => a.raisePropertyChanged("ActualTrendLineBrush", b.oldValue, b.newValue)));
    FinancialIndicator.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, FinancialIndicator, 'raisePropertyChanged', ['DisplayType:x8:yn', [IndicatorDisplayType_$type, /*@__PURE__*/ enumGetBox(IndicatorDisplayType_$type, 0)], 'IgnoreFirst:ye:yo', [1, 0], 'TrendLineType::yu', [TrendLineType_$type, /*@__PURE__*/ enumGetBox(TrendLineType_$type, 0)], 'TrendLineThickness::yt', [1, 1.5], 'TrendLinePeriod::ys', [1, 7], 'TrendLineBrush::yp', [Brush.$, null], 'TrendLineZIndex:yf:yv', [1, 1001], 'TrendLineDashArray:yx:yq', [DoubleCollection.$], 'TrendLineDashCap:yy:yr', [PenLineCap_$type, /*@__PURE__*/ enumGetBox(PenLineCap_$type, 0)]]);
    return FinancialIndicator;
})();
/**
 * @hidden
 */
export let FinancialIndicatorBucketCalculator = /*@__PURE__*/ (() => {
    class FinancialIndicatorBucketCalculator extends FinancialBucketCalculator {
        constructor(a) {
            super(a);
            this.f = null;
            this.f = a;
        }
        getBucket(a) {
            let b = a * this.b;
            let c = Math.min(b + this.b - 1, this.f.b6.indicatorColumn.count - 1);
            let d = NaN;
            let e = NaN;
            for (let f = b; f <= c; ++f) {
                let g = this.f.b6.indicatorColumn._inner[f];
                if (!isNaN_(d)) {
                    if (!isNaN_(g)) {
                        d = Math.min(d, g);
                        e = Math.max(e, g);
                    }
                }
                else {
                    d = g;
                    e = g;
                }
            }
            if (!isNaN_(d)) {
                return [0.5 * (b + c), d, e];
            }
            return [NaN, NaN, NaN];
        }
    }
    FinancialIndicatorBucketCalculator.$t = /*@__PURE__*/ markType(FinancialIndicatorBucketCalculator, 'FinancialIndicatorBucketCalculator', FinancialBucketCalculator.$);
    return FinancialIndicatorBucketCalculator;
})();
/**
 * @hidden
 */
export let FinancialIndicatorView = /*@__PURE__*/ (() => {
    class FinancialIndicatorView extends FinancialSeriesView {
        constructor(a) {
            super(a);
            this.b6 = null;
            this.b9 = null;
            this.cx = ((() => {
                let $ret = new Path();
                $ret.an = new PathGeometry();
                return $ret;
            })());
            this.ct = ((() => {
                let $ret = new Path();
                $ret.an = new PathGeometry();
                return $ret;
            })());
            this.cy = ((() => {
                let $ret = new Path();
                $ret.an = new PathGeometry();
                return $ret;
            })());
            this.cu = ((() => {
                let $ret = new Path();
                $ret.an = new PathGeometry();
                return $ret;
            })());
            this.cz = ((() => {
                let $ret = new Path();
                $ret.an = new PathGeometry();
                return $ret;
            })());
            this.cv = ((() => {
                let $ret = new Path();
                $ret.an = new PathGeometry();
                return $ret;
            })());
            this.cw = ((() => {
                let $ret = new Path();
                $ret.an = new GeometryGroup();
                return $ret;
            })());
            this.cs = ((() => {
                let $ret = new Path();
                $ret.an = new GeometryGroup();
                return $ret;
            })());
            this.b7 = null;
            this.cp = new Path();
            this.cr = new Path();
            this.cq = new Path();
            this.co = new Path();
            this.cl = new Path();
            this.cn = new Path();
            this.cm = new Path();
            this.ck = new Path();
            this.b6 = a;
            this.b9 = ((() => {
                let $ret = new Pool$1(LineGeometry.$);
                $ret.create = runOn(this, this.cj);
                $ret.destroy = runOn(this, this.cc);
                return $ret;
            })());
        }
        b1() {
            return new FinancialIndicatorBucketCalculator(this);
        }
        au() {
            super.au();
            if (!this.q) {
                this.b6.x1 = Defaults.ah;
                this.b6.x8 = this.b6.x7;
            }
        }
        cj() {
            return new LineGeometry();
        }
        cc(a) {
        }
        get b8() {
            if (this.b7 == null) {
                this.b7 = CategoryTrendLineManagerFactory.a(this.b7, this.e.as(), this.e.qt, this.e, this.e.da);
            }
            return this.b7;
        }
        set b8(a) {
            this.b7 = a;
        }
        get ca() {
            return this.b7 != null;
        }
        cb(a) {
            Extensions.e(this.cx.an);
            Extensions.e(this.cy.an);
            Extensions.e(this.cz.an);
            Extensions.e(this.ct.an);
            Extensions.e(this.cu.an);
            Extensions.e(this.cv.an);
            Extensions.d(this.cw.an);
            Extensions.d(this.cs.an);
            if (a) {
                this.b9.count = 0;
            }
            this.as();
        }
        ch() {
        }
        cf(a, b, c, d, e) {
            IndicatorRenderer.g(a, b, c, d, this.by, this.bx, this.cx, this.ct, this.b0.b, this.e.hk, e);
            this.as();
        }
        cd(a, b, c, d, e, f) {
            IndicatorRenderer.e(a, b, c, d, this.by, this.bx, this.cx, this.cy, this.ct, this.cu, e, this.b0.b, this.e.hk, f);
            this.as();
        }
        ce(a, b, c, d, e) {
            IndicatorRenderer.f(a, b, c, d, this.bx, e, this.b9, this.cw, this.cs);
            this.as();
        }
        ci() {
            this.b6.yw = null;
            if (this.b6.trendLineBrush != null) {
                this.b6.yw = this.b6.trendLineBrush;
            }
            else {
                this.b6.yw = this.b6.su;
            }
        }
        be() {
            super.be();
            let a = this.br();
            this.cp.an = this.cx.an;
            this.cr.an = this.cz.an;
            this.cq.an = this.cy.an;
            this.co.an = this.cw.an;
            this.cl.an = this.ct.an;
            this.cn.an = this.cv.an;
            this.cm.an = this.cu.an;
            this.ck.an = this.cs.an;
            this.cp._stroke = a;
            this.cr._stroke = a;
            this.cp.ad = this.e.hl + 3;
            this.cr.ad = this.e.hl + 3;
            this.cq._fill = a;
            this.cq._opacity = 1;
            this.co._stroke = a;
            this.co.ad = this.e.hl + 3;
            this.cl._stroke = a;
            this.cn._stroke = a;
            this.cl.ad = this.e.hl + 3;
            this.cn.ad = this.e.hl + 3;
            this.cm._fill = a;
            this.cm._opacity = 1;
            this.ck._stroke = a;
            this.ck.ad = this.e.hl + 3;
        }
        a8(a, b) {
            super.a8(a, b);
            if (a.d) {
                if (b) {
                    if (this.b6.x8 == 2) {
                        a.t(this.co);
                        a.t(this.ck);
                    }
                    else {
                        a.t(this.cq);
                        a.t(this.cp);
                        a.t(this.cr);
                        a.t(this.cm);
                        a.t(this.cl);
                        a.t(this.cn);
                    }
                }
                else {
                    if (this.b6.x8 == 2) {
                        a.t(this.cw);
                        a.t(this.cs);
                    }
                    else {
                        a.t(this.cy);
                        a.t(this.cx);
                        a.t(this.cz);
                        a.t(this.cu);
                        a.t(this.ct);
                        a.t(this.cv);
                    }
                }
            }
        }
        a7(a, b) {
            if (a.d) {
                if (this.b6.trendLineType != 0 && !b) {
                    let c = this.b8.g$j;
                    c.ad = this.b6.trendLineThickness;
                    c._stroke = this.b6.yw;
                    c.aj = this.b6.yy;
                    c.ai = this.b6.yx;
                    a.v(c);
                }
            }
            super.a7(a, b);
        }
        an(a) {
            super.an(a);
            this.e.a5.exportPathData(a, this.cw, "positiveColumnsShape", ["Positive", "Main"]);
            this.e.a5.exportPathData(a, this.cs, "negativeColumnsShape", ["Negative"]);
            this.e.a5.exportPathData(a, this.cx, "positive0", ["Positive", "Main"]);
            this.e.a5.exportPathData(a, this.cz, "positive1", ["Positive"]);
            this.e.a5.exportPathData(a, this.cy, "positive01", ["PositiveFill"]);
            this.e.a5.exportPathData(a, this.ct, "negative0", ["Negative", "Main"]);
            this.e.a5.exportPathData(a, this.cv, "negative1", ["Negative"]);
            this.e.a5.exportPathData(a, this.cu, "negative01", ["NegativeFill"]);
        }
        cg() {
            if (this.ca) {
                this.b7 = CategoryTrendLineManagerFactory.a(this.b7, this.e.as(), this.e.qt, this.e, this.e.da);
            }
        }
    }
    FinancialIndicatorView.$t = /*@__PURE__*/ markType(FinancialIndicatorView, 'FinancialIndicatorView', FinancialSeriesView.$);
    return FinancialIndicatorView;
})();
